package net.stoerr.sudoku;

/**
 * The store where we store the constraints. New constraints derived from the constraints are added here.
 * @author hps
 * @param <P> type of the points
 */
public interface ConstraintStore<P extends Comparable<P>> {
    /**
     * Adds a constraint to the store - a string of possible digits for the point.
     * @param idx
     * @param val
     */
    void setConstraint(P idx, String val);

    /**
     * Returns the possibilities for the point as string of digits.
     * @param idx
     * @return
     */
    String getConstraint(P idx);
}
