package net.stoerr.sudoku;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.border.AbstractBorder;
import javax.swing.border.Border;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;

public class SudokuCellRenderer extends DefaultTableCellRenderer implements TableCellRenderer {

    @Override
    public Component getTableCellRendererComponent(final JTable table, final Object value, final boolean isSelected,
            final boolean hasFocus, final int row, final int column) {
        final JLabel res = (JLabel) super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
        res.setHorizontalAlignment(CENTER);
        res.setVerticalAlignment(CENTER);
        res.setText(formatValue((String) value));
        final Border border = new AbstractBorder() {
            @Override
            public void paintBorder(final Component c, final Graphics g, final int x, final int y, final int width,
                    final int height) {
                g.setColor(0 == row % 3 ? Color.black : Color.lightGray);
                g.drawLine(0, 0, width - 1, 0);
                g.setColor(2 == row % 3 ? Color.black : Color.lightGray);
                g.drawLine(0, height - 1, width - 1, height - 1);
                g.setColor(0 == column % 3 ? Color.black : Color.lightGray);
                g.drawLine(0, 0, 0, height - 1);
                g.setColor(2 == column % 3 ? Color.black : Color.lightGray);
                g.drawLine(width - 1, 0, width - 1, height - 1);
            }
        };
        res.setBorder(border);
        return res;
    }

    private String formatValue(final String value) {
        final StringBuilder buf = new StringBuilder(50);
        buf.append("<html> ");
        for (int i = 0; i < value.length(); ++i) {
            if (0 == i % 3 && 0 < i) buf.append(" <br/> ");
            else buf.append(" ");
            buf.append(value.charAt(i));
        }
        buf.append("</html>");
        return buf.toString();
    }

}
