package net.stoerr.sudoku;

import java.awt.Dimension;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

/**
 * Frame to display the sudoku solver. (visual editor.)
 */
public class SudokuFrame extends JFrame {
    private static final long serialVersionUID = 1L;
    private JPanel jContentPane = null;

    /**
     * This is the default constructor
     */
    public SudokuFrame() {
        super();
        initialize();
    }

    /**
     * This method initializes this
     */
    private void initialize() {
        setContentPane(getJContentPane());
        setTitle("Soduko Solver");
        this.setSize(new Dimension(600, 950));
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setResizable(true);
    }

    /**
     * This method initializes jContentPane
     * @return javax.swing.JPanel
     */
    private JPanel getJContentPane() {
        if (jContentPane == null) jContentPane = new SudokuPanel();

        return jContentPane;
    }

    /**
     * Start the program.
     * @param args
     */
    public static void main(final String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                final SudokuFrame thisClass = new SudokuFrame();
                thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                thisClass.setVisible(true);
            }
        });
    }
}
